/**
 * ҳԤ
 * @class FR.PagePane
 * @extends FR.BasePane
 */
$.extend(FR.PagePane.prototype, /**@class FR.PagePane*/{
    /**
     * @property {Number} ǰҳҳе
     */
    currentPageIndex:0, // ReportPageReportPageе

    /**
     * @property {Number} ҳ
     */
    reportTotalPage:0, // ReportPageReportPageɵܵReportPageĸ

    /**
     * @property {Number} ڼصҳ
     */
    isLoadingPage:-1,

    /**
     * @property {Number} Ѿصҳɵ
     */
    pagesLoaded : [],
    pagesBorder: false, //ǷʾҳԤʱı߿,ʱʾ

    /**
     * ת򱨱ĵһҳ
     * e.g. contentPane.gotoFirstPage();
     */
    gotoFirstPage:function() {
        this.gotoPage(1);
    },

    /**
     * ת򱨱һҳ
     */
    gotoPreviousPage:function () {
        if (this.currentPageIndex <= 1) {
            return;
        }
        this.gotoPage(this.currentPageIndex - 1);
    },

    /**
     * ת򱨱һҳ
     */
    gotoNextPage:function() {
        this.gotoPage(this.currentPageIndex + 1);
    },

    /**
     * ת򱨱һҳ
     */
    gotoLastPage:function() {
        this.gotoPage(2147483647);
    },

    /**
     * ת򱨱ָҳ
     * @param {Number} pn ҳ
     */
    gotoPage:function(pn) {
    	if (typeof pn != 'number' || isNaN(pn)) {
    		return;
    	}
    	if (pn < 1){
    		pn = 1;
    	}
    	// ʾڼҳ
    	if (this.isLoadingPage >= 0) {
    		return;
    	}
    	this.fireEvent(FR.Events.STARTLOAD);
    	
    	// ڼҳ
    	this.isLoadingPage = pn;
    	
		//sheetԤ, ĳsheetóhidden, sheetǶʱĬoverflow:auto, Ȼʧ
  		this.$contentPane.css({
       		overflow : 'auto'
       	});
    	
    	// alex:ǿinnerHTMLΪַ,jQuery.html()empty(),ܷʱ
		this.$contentPane.__load__({
			url : FR.servletURL,
			params : {op : "page_content",sessionID : this.currentSessionID, pn:pn},
			scripts : true,
			forceDisplay : true,
			timeout : 3600000,
            loadHtml: function (html) {
                if ($.browser.msie && $.browser.version >= 9.0
                    || $.browser.mozilla && parseInt($.browser.version) === 11.0) {
                    for (var i = 0; i < this.length; i++) {
                        this[i].innerHTML = html;
                    }
                }else{
                    this.html(html);
                }
            },
			callback : function() {
                FR._executeScriptFromHtml(this.$contentPane.html());
				this.fireEvent(FR.Events.AFTERLOAD);

				// carl:ʱֻͼ
				this.$contentPane.asComponent({type : "fr_form", selector : 'td[widget]'});
                var $contentDIV = $(".pageContentDIV",  this.$contentPane);
                var borderCss = '1px solid rgb(149, 149, 149)';
				var $frozenPage = $(".frozen-page", this.$contentPane);
				
				if ($frozenPage.length > 0) {
					// richer:ʼ׼
					var isCenter = $contentDIV.hasClass("contentDIV");
			       
					if (isCenter) {	// denny: ңʾ
                        //Sean: Ҷʱʾ߿򣬷򲻺ÿ
                        $contentDIV.css('border',borderCss);
						var self = this;
						var frozen_layout = function() {
							self.$contentPane.css("overflow", "hidden");
							$frozenPage.css("height", $contentDIV.height() - parseInt($('.report-background', $contentDIV).css("top")));
							var pageWidth = Math.min(self.$contentPane.width(), $contentDIV.width());
							$frozenPage.css("width", pageWidth - parseInt($('.report-background', $contentDIV).css("left")));
							FR.layoutFrozen($frozenPage, self.$contentPane.offset().top);
						};
						frozen_layout();
						
						//17ǹ߶
						var $footer = $(".HF-footer", this.$container);
						var footerTop = $('.frozen-center').height() + $('.frozen-north').height() - $footer.height() - 17 +
										parseInt($('.report-background').css('top'));
						$footer.css('top', footerTop + 'px');
					} else {
						
						this.$contentPane.asComponent({type : "border", items:[{region: 'center',el: $contentDIV}]});	
						
						var regions = [{region: 'center', el: $frozenPage}];
						var $header = $(".HF-header", this.$container);
						if ($header.length > 0) {
							regions.push({region: 'north', el:$header});
				       	}			
						var $footer = $(".HF-footer", this.$container);
						if ($footer.length > 0) {
							regions.push({region: 'south', el: $footer});
						}
						
						$contentDIV.asComponent({type : "border", items:regions});	
						FR.layoutFrozen($frozenPage, this.$contentPane.offset().top);
						this.$contentPane.doLayout();
			       }
			       
			       if ($.browser.msie && parseInt($.browser.version) < 9 && $.support.boxModel === true) {
						var initColCell = function(element, ano_row_ranges) {
							var col_ranges = [];
							col_ranges[0] = 0;
							var $cols = element.find('colgroup:eq(0)').children();
							var $col;
							var row_size = col_ranges.length;
							$.each($cols, function(idx, col){
								$col = $(col);
								if (ano_row_ranges) {
									var h = ano_row_ranges[idx + row_size] - ano_row_ranges[idx + row_size - 1];
									if (col.offsetWidth != h) {
										var ofs = parseInt($col.css("width")) + h - col.offsetWidth;
										$col.css("width", ofs);
										if (idx === 0 && col.offsetWidth !== h) {
											$col.css("width", ofs + h - col.offsetWidth);
										}
									}
								} else {
									col_ranges[idx + row_size] = col_ranges[idx + row_size - 1] + col.offsetWidth;
								}
							});
							return col_ranges;
						};
						
						var f_corner = $('.frozen-corner', this.$container);
						if (f_corner.length > 0) {
							var col_ranges = initColCell($('.frozen-west', this.$container));
							initColCell(f_corner, col_ranges);
						}
					}
			    }else{
                    if(this.pagesBorder === true){
                        $contentDIV.css('border',borderCss);
                    }else{
                        $contentDIV.css('border','none');
                    }
                }

                //wikky:ҳŵtop£ֹҳڵ
                if($(".HF-footer", this.$container).length > 0) {
                var tableHeight = $(".report-background",this.$container).find("table").height();
                var backgroundHeight = $(".report-background",this.$container).height();
                var contentHeight = tableHeight > backgroundHeight ? tableHeight : backgroundHeight;
                var topHeight = $.browser.msie && parseInt($.browser.version) < 9 ? parseInt($("#fr-page-content",this.$container).css("top")) :parseInt($(".report-background",this.$container).css("top"));
                if($(".HF-header", this.$container).length > 0) {
                    topHeight = parseInt($(".HF-header", this.$container).css("top")) + $(".HF-header", this.$container).height()
                }
                var footerTop = contentHeight + topHeight + 1;                     //wikky:+1Ϊ˷ֹ߿ڵ
                $(".HF-footer", this.$container).css("top",footerTop);
                }
                // IE8 ģʽ ˱߿ ϷһtrصĻ ϱ߿ͻϸ òborder-collapse
                if ($.browser.msie && $.browser.version == '8.0' && !$.support.boxModel) {
                    var blankTr = $('tr:hidden', this.$contentPane);
                    for (var i=0; i<blankTr.length; i++) {
                        var nextTr = blankTr.eq(i).next('tr');
                        for(var j=0; j<nextTr.children().length; j++) {
                            var td = nextTr.children().eq(j);
                            for (var k=1; k<4; k++) {
                                if (td.hasClass('btw' + k)) {
                                    td.css('border-top-width', k*2);
                                }
                            }
                        }
                    }
                }

                // ȡڼҳı
                this.isLoadingPage = -1;

                // 48070 ƶchrome
                if($.browser.chrome && FR.isMobile()) {
                    $('body').css('overflow', 'auto');
                }

            }.createDelegate(this)
		});
    },

    _setTotalPageByHtml: function () {
        var html_script = this.$contentPane.html().substring(0, 100);
        var begin = html_script.indexOf("<"+"script>");
        var end = html_script.indexOf("</"+"script>");
        html_script = html_script.substring(begin + 8, end);
        eval(html_script);
    },

    pageSetup:function () {
    	// jim: pageȥ˶Ի
        this.showPageSetupDialog({sessionID:this.currentSessionID});
    },
    printReportServer:function () {
        FR.showIframeDialog({
            title:FR.i18nText("ReportServerP-Print[Server]"),
            width:540,
            height:380,
            url:FR.servletURL + "?op=fr_dialog&cmd=read_print_server_dialog&sessionID=" + this.currentSessionID + "&pn=" + this.currentPageIndex
        });
    },
    emailReport:function () {
        if (this.fireEvent(FR.Events.BEMAIL) === false) {
            return;
        }
        var self = this;
        FR.showEmailDialog({sessionID:this.currentSessionID, onFinish : function(){
            self.fireEvent(FR.Events.AEMAIL);
        }});
    },
    appletPrint:function () {
        FR.doAppletPrint(this.currentSessionID);
    },
    flashPrint:function () {
        FR.doFlashPrint(this.currentSessionID, this.currentPageIndex);
    },
    exportReportToPDF:function (extype) {
        if (this.fireEvent(FR.Events.BTOPDF) === false) {
            return;
        }
        window.location = FR.servletURL + "?op=export&sessionID=" + this.currentSessionID + "&format=pdf&extype=" + extype;
        this.fireEvent(FR.Events.ATOPDF);
    },
    exportReportToExcel:function (extype) {
        if (this.fireEvent(FR.Events.BTOEXCEL) === false) {
            return;
        }
        // carl:Ūʾ
        if (extype == 'ldpage') {
            FR.Msg.toast(FR.i18nText("Export-Excel-LargeData-Page-Info"));
        }
        window.location = FR.servletURL + "?op=export&sessionID=" + this.currentSessionID + "&format=excel&extype=" + extype;
        this.fireEvent(FR.Events.ATOEXCEL);
    },
    exportReportToCSV:function () {
        window.location = FR.servletURL + "?op=export&sessionID=" + this.currentSessionID + "&format=csv";
    },
    exportReportToWord:function () {
        if (this.fireEvent(FR.Events.BTOWORD) === false) {
            return;
        }
        window.location = FR.servletURL + "?op=export&sessionID=" + this.currentSessionID + "&format=word";
        this.fireEvent(FR.Events.ATOWORD);
    },
    exportReportToImage:function (extype) {
        if (this.fireEvent(FR.Events.BTOIMAGE) === false) {
            return;
        }
        window.location = FR.servletURL + "?op=export&sessionID=" + this.currentSessionID + "&format=image&extype=" + extype;
        this.fireEvent(FR.Events.ATOIMAGE);
    },
    exportReportToHtml:function () {
        if (this.fireEvent(FR.Events.BTOHTML) === false) {
            return;
        }
        window.location = FR.servletURL + "?op=export&sessionID=" + this.currentSessionID + "&format=html";
        this.fireEvent(FR.Events.ATOHTML);
    },
    printPreview:function () {
        window.open(FR.servletURL + "?op=print_preview&cmd=pw_init_page&__pi__=false&sessionID=" + this.currentSessionID, "_blank", "Scrollbar=yes,Resizable=yes,fullscreean=yes");
    },
    SetPrinterOffset:function () {
        FR.showIframeDialog({
            title:FR.i18nText("SetPrinterOffset"),
            width:420,
            height:300,
            url:FR.servletURL + "?op=printer_offset&cmd=pt_open&sessionID=" + this.currentSessionID
        });
    },
	initContentPane : function() {

		this.on("afterload", function() {
			this.autoScale();
		});

	},
	loadContentPane : function() {
		this.gotoPage(1);
	},
    _initSheetTabPane: function ($contentPane, sheetsO) {
    	//д_initSheetTabPane, ҳҪsheetPane
        $contentPane.css("overflow", "auto").css('border-top', '0px');
    },

    /**
     * ǷʾҳԤʱı߿
     * Ҫҳļʼ¼
     * @param isVisible
     */
    setBorderVisible: function(isVisible){
        this.pagesBorder = isVisible;
    }
});

function onBridgeReady(event) {
	contentPane.bridge = event.bridge;
//	if(contentPane.parameterEl) {
//		contentPane.bridge.send('hidetb');
//	}
	FR.MobileTools.doWaitingTODO();
	contentPane.bridge.init(function(message) {
//		if(message === "cached") {
//			var isSessionAlive = FR.checkIsSessionAlive();
//			if(isSessionAlive === "true") {
//				return;
//			} else {
//				contentPane.bridge.send("dead");
//			}
//		} else {
			contentPane.gotoPage(parseInt(message));	
//		}
	});
}

//for ios
if(FR.isMobile()) {
	document.addEventListener('WebViewJavascriptBridgeReady', onBridgeReady, false);
}
